#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: generate_vps_graphs.pl, v2.0.0-1 Fri 28 Oct 2011 09:59:26 AM CEST mstauber Exp $
# Copyright 2006-2011 Stauber Multimedia Design. All rights reserved.
#
# Handler which writes / updates the user_beancounter RRD graphs.
#

use CCE;
use POSIX qw(isalpha);

my $DEBUG = 0;

my $cce = new CCE('Domain' => 'base-vserver');

$cce->connectfd();

($sys_oidmasternode) = $cce->find('VserverTraffic');
($ok, $VserverTraffic) = $cce->get($sys_oidmasternode);
$vpsid = $VserverTraffic->{generate_vps_graphs};

($sys_vserver) = $cce->find('Vserver', {'vpsid' => $vpsid});
($ok, $Vserver) = $cce->get($sys_vserver);
$last_graph = $Vserver->{last_graph};

$nowtime = time();

# Find if we need to update the graphics now or not:
if ($last_graph + 180 > $nowtime) {
    # Last update was less than 3 minutes ago. Do nothing now.
    $do_update = "1";

    # We need to say 'SUCCESS' or CCE will bitch:
    $cce->bye('SUCCESS');
    exit(0);
}

my $vserver = $cce->event_object();
my $vserver_new = $cce->event_new();
my $vserver_old = $cce->event_old();

if (($vserver_new->{generate_graphs_multi}) || ($vserver_new->{generate_vps_graphs})) {
    $rrd_file = "/usr/sausalito/ui/web/base/traffic/vpsimages/" . $vpsid . "/" . $vpsid . ".rrd";
    if ( ! -f $rrd_file) {
	system("/usr/sausalito/sbin/system_graphs.pl update");
    }
    system("/bin/chmod 644 $rrd_file");
    system("/usr/sausalito/sbin/system_graphs.pl graph daily $vpsid");
    system("/usr/sausalito/sbin/system_graphs.pl graph weekly $vpsid");
    system("/usr/sausalito/sbin/system_graphs.pl graph monthly $vpsid");
    system("/usr/sausalito/sbin/system_graphs.pl graph yearly $vpsid");
    $rrd_images = "/usr/sausalito/ui/web/base/traffic/vpsimages/" . $vpsid . "/" . "*.png";
    system("/bin/chmod 644 $rrd_images");
}

# We need to say 'SUCCESS' or CCE will bitch:
$cce->bye('SUCCESS');
exit(0);

